
/**
 * GridExpandableRow.java
 */
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.*;
import java.beans.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.table.*;

import jbc.grid.*;
/*
 * This sample shows the ability of expanding a row.
 */
 
/**
 * Class:   GridExpandableRow
 */
public class GridExpandableRow extends GridExpandableRow_Abstract
   {
    /**
     * Constructor: GridExpandableRow
     * @return instance of GridExpandableRow
     */
    public GridExpandableRow()
       {
        super();
        loadProgramsTable();     
       } /* End of Constructor: GridExpandableRow */
    /**
     * loadProgramsTable
     */
    private void loadProgramsTable()
       {
        get_ProgramName().setCellRenderer(new JbcCellRenderer());
        get_ProgramName().setCellEditor(new JbcCellEditorNoEditable());
        get_ProgramSize().setCellRenderer(new JbcCellRendererRight());
        get_ProgramSize().setCellEditor(new JbcCellEditorNoEditable());
        get_ProgramDate().setCellRenderer(new JbcCellRenderer());
        get_ProgramDate().setCellEditor(new JbcCellEditorNoEditable());        
        
        JbcGridDefaultTableModel tm = (JbcGridDefaultTableModel)get_ProgramsTable().getModel();   
        Vector data;

        data = new Vector();
        data.add("VisualMust - Interface Builder");
        data.add(new Integer(1500));        
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(new Date());
        calendar.set(Calendar.MINUTE,calendar.get(Calendar.MINUTE) -1);
        calendar.set(Calendar.SECOND, -10);        
        data.add(calendar.getTime());
        tm.addRow(data); 
                
        data = new Vector();
        data.add("Ethernet Adapter and Software");
        data.add(new Integer(123));       
        calendar = Calendar.getInstance();
        calendar.setTime(new Date());
        calendar.set(Calendar.HOUR_OF_DAY,calendar.get(Calendar.HOUR_OF_DAY) - 3333);
        calendar.set(Calendar.MINUTE,calendar.get(Calendar.MINUTE) + 333);
        calendar.set(Calendar.SECOND, -33);        
        data.add(calendar.getTime());
        tm.addRow(data);       
                   
        data = new Vector();
        data.add("Wizard Host Online");
        data.add(new Integer(400));
        calendar = Calendar.getInstance();
        calendar.setTime(new Date());
        calendar.set(Calendar.HOUR_OF_DAY,calendar.get(Calendar.HOUR_OF_DAY) - 2222);
        calendar.set(Calendar.MINUTE,calendar.get(Calendar.MINUTE) - 222);
        calendar.set(Calendar.SECOND, -22);        
        data.add(calendar.getTime());
        tm.addRow(data);
         
        data = new Vector();
        data.add("Text Editor");
        data.add(new Integer(80));
        calendar = Calendar.getInstance();
        calendar.setTime(new Date());
        calendar.set(Calendar.HOUR_OF_DAY,calendar.get(Calendar.HOUR_OF_DAY) - 1111);
        calendar.set(Calendar.MINUTE,calendar.get(Calendar.MINUTE) + 111);
        calendar.set(Calendar.SECOND, -11);        
        data.add(calendar.getTime());
        tm.addRow(data);  
         
        data = new Vector();
        data.add("Mail Software");
        data.add(new Integer(320));
        calendar = Calendar.getInstance();
        calendar.setTime(new Date());
        calendar.set(Calendar.HOUR_OF_DAY,calendar.get(Calendar.HOUR_OF_DAY) - 11);
        calendar.set(Calendar.MINUTE,calendar.get(Calendar.MINUTE) + 11);
        calendar.set(Calendar.SECOND, -30);        
        data.add(calendar.getTime());
        tm.addRow(data);  
         
        data = new Vector();
        data.add("Internet Software");
        data.add(new Integer(400));
        calendar = Calendar.getInstance();
        calendar.setTime(new Date());
        calendar.set(Calendar.HOUR_OF_DAY,calendar.get(Calendar.HOUR_OF_DAY) - 3);
        calendar.set(Calendar.MINUTE,calendar.get(Calendar.MINUTE) + 3);
        calendar.set(Calendar.SECOND, -3);        
        data.add(calendar.getTime());
        tm.addRow(data);                                                  
       } /* End of Method : loadProgramsTable */
       
    /**
     * Method: init_ProgramsTable <br>
     * @param Instance of jbc.grid.JbcGridTable
     * @return jbc.grid.JbcGridTable
     */
    protected jbc.grid.JbcGridTable init_ProgramsTable(jbc.grid.JbcGridTable self)
       {
        self.setModel(new GridTableModel(self));
        return super.init_ProgramsTable(self);
       } /* End of Method: init_ProgramsTable */ 

    class GridTableModel extends JbcGridDefaultTableModel implements ListSelectionListener
       {
        jbc.grid.JbcGridTable table;
        GridTableModel(jbc.grid.JbcGridTable table)
           {            
            this.table = table;
            ListSelectionModel lsm = (ListSelectionModel)table.getSelectionModel();
            lsm.addListSelectionListener(this);
           }

        public JComponent getExpandedRowComponent(int row)
           {
            get_ProgramPanelName().setText("" + getValueAt(row,0));
            get_ProgramPanelSize().setText("" + getValueAt(row,1) + " k");   
            get_ProgramPanelDate().setText("" + getValueAt(row,2));         
            return get_ProgramPanel();
           }

        public boolean isCellEditable(int row, int column)
           {
            return false;
           }

        public void valueChanged(final ListSelectionEvent e)
           {
            ListSelectionModel lsm = (ListSelectionModel)table.getSelectionModel();
            int row = e.getFirstIndex();
            table.setExpandedRow(row,lsm.isSelectedIndex(row));
            row = e.getLastIndex();
            table.setExpandedRow(row,lsm.isSelectedIndex(row));
           }
       }
  

    /**
     * Method: generalHandleException <br>
     * @param java.lang.Throwable exception
     * @return void
     */
    protected void generalHandleException(java.lang.Throwable exc)
       {
        exc.printStackTrace(System.err);
       } /* End of Method: generalHandleException */

    /**
     * Method: main <br>
     * Note: Called only if we're an application. <br>
     * @param java.lang.String[] args the command line arguments
     * @return void
     */
    public static void main(java.lang.String[] args)
       {
        try
           {
            /* Set native look and feel */
            javax.swing.UIManager.setLookAndFeel(javax.swing.UIManager.getSystemLookAndFeelClassName());

            /* Creates new MainObject */
            GridExpandableRow self = new GridExpandableRow();
            self.show();
           } /* End try */
        catch (java.lang.Throwable exc)
           {
            exc.printStackTrace(System.err);
           } /* End catch */
       } /* End of Method: main */

    /**
     * Method: JButton_action_actionPerformed <br>
     * Adapter: ActionAdapter <br>
     * Interface: java.awt.event.ActionListener <br>
     * Note  : This method is called when an action occurs.  <br>
     * @param java.awt.event.ActionEvent evt
     * @return void
     */
    protected void JButton_action_actionPerformed(java.awt.event.ActionEvent evt)
       {
        int row = JbcGridTable.getRowFromComponent(get_JButton());
        JbcGridTable table = JbcGridTable.getGridTableFromComponent(get_JButton());
        // table.setExpandedRow(row,false);  
        table.removeRowSelectionInterval(row, row);
       } /* End of Method: JButton_action_actionPerformed */

   } /* End of Class: GridExpandableRow */



