
/**
 * GridTreeView.java
 */
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.*;
import java.beans.*;
import javax.swing.*;
import javax.swing.event.*; 
import javax.swing.text.*;
import javax.swing.table.*;

import jbc.beans.*;
import jbc.grid.*;

/* 
 * This sample shows the ability of nesting tables or components.
 */
 
/**
 * Class:   GridTreeView
 */
public class GridTreeView extends GridTreeView_Abstract
   {
    String stringsClass[] =
       {
        "Economy", "First"
       };
     
     String stringsRow[] =
       {
        "A", "B", "C", "D", "E"
       };
       
    /**
     * Constructor: GridTreeView
     * @return instance of GridTreeView
     */
    public GridTreeView()
       {
        super();  
        Point screenLocation = new Point(0, 0);
        Dimension screenSize = getToolkit().getScreenSize();
        screenSize.width /= 2;
        screenSize.width -= (getSize().width / 2);
        screenSize.height /= 2;
        screenSize.height -= (getSize().height / 2);
        setLocation(screenLocation.x + screenSize.width,
                    screenLocation.y + screenSize.height);          
       } /* End of Constructor: GridTreeView */

    /**
     * loadFlightsTable
     */
    private void loadFlightsTable()
       {
        get_FlightColumn().setCellRenderer(new JbcCellRendererCenter());
        get_FlightColumn().setCellEditor(new JbcCellEditorNoEditable());
        get_DepartureCity().setCellRenderer(new JbcCellRenderer());
        get_DepartureCity().setCellEditor(new JbcCellEditorTextField());
        get_Destination().setCellRenderer(new JbcCellRenderer());
        get_Destination().setCellEditor(new JbcCellEditorTextField()); 
        if (get_JRadioButtonFull().isSelected())
           {
            try // JbcBeans
               {
                JbcCellEditorDateTime cedt = new JbcCellEditorDateTime(JbcDateTimeChooser.FULL);                              
                get_DepartureDate().setCellEditor(cedt);
                JbcDateTimeChooser dtc = (JbcDateTimeChooser)cedt.getComponent();
                dtc.setSecondEnabled(false);
                dtc.setClockWithAmPm(true);
                get_DepartureDate().setCellRenderer(new JbcCellRendererDateTime(JbcDateTimeChooser.FULL));            
               }
            catch (java.lang.Throwable exc) 
               {
                get_JRadioButtonFull().setSelected(false);
               }            
           }
        if (!get_JRadioButtonFull().isSelected())
           {
            get_DepartureDate().setCellRenderer(new JbcCellRenderer());            
           }     
        
        JbcGridDefaultTableModel tm = (JbcGridDefaultTableModel)get_FlightsTable().getModel();   
        Vector data;
        data = new Vector();
        data.add(new Integer(4067));
        data.add("New York");
        data.add("Paris");        
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(new Date());
        calendar.set(Calendar.SECOND, 0);                
        data.add(calendar.getTime());
        tm.addRow(data);  
                   
        data = new Vector();
        data.add(new Integer(4080));
        data.add("Paris");
        data.add("New York");
        calendar = Calendar.getInstance();
        calendar.setTime(new Date());       
        calendar.set(Calendar.HOUR_OF_DAY,calendar.get(Calendar.HOUR_OF_DAY) - 7);
        calendar.set(Calendar.MINUTE,calendar.get(Calendar.MINUTE) + 33);
        calendar.set(Calendar.SECOND, 0);        
        data.add(calendar.getTime());
        tm.addRow(data);       
                   
        data = new Vector();
        data.add(new Integer(5580));
        data.add("London");
        data.add("New York");
        calendar = Calendar.getInstance();
        calendar.setTime(new Date());
        calendar.set(Calendar.MINUTE,calendar.get(Calendar.MINUTE) + 55);
        calendar.set(Calendar.SECOND, 0);        
        data.add(calendar.getTime());
        tm.addRow(data);
         
        data = new Vector();
        data.add(new Integer(8900));
        data.add("Paris");
        data.add("London");
        calendar = Calendar.getInstance();
        calendar.setTime(new Date());
        calendar.set(Calendar.MINUTE,calendar.get(Calendar.MINUTE) + 77);
        calendar.set(Calendar.SECOND, 0);        
        data.add(calendar.getTime());
        tm.addRow(data);  
         
        data = new Vector();
        data.add(new Integer(7123));
        data.add("London");
        data.add("Paris");
        calendar = Calendar.getInstance();
        calendar.setTime(new Date());
        calendar.set(Calendar.MINUTE,calendar.get(Calendar.MINUTE) + 99);
        calendar.set(Calendar.SECOND, 0);        
        data.add(calendar.getTime());
        tm.addRow(data);                         
       } /* End of Method : loadFlightsTable */
       
    /**
     * Method: init_FlightsTable <br>
     * @param Instance of jbc.grid.JbcGridTable
     * @return jbc.grid.JbcGridTable
     */
    protected jbc.grid.JbcGridTable init_FlightsTable(final jbc.grid.JbcGridTable self)
       {
        self.setModel(new JbcGridDefaultTableModel()
           {  
            public boolean isExpandableTreeview(int row)
               {
                // return (row < getRowCount()-2); // row 0, 1, 2
                int dataBaseIndex = self.convertRowToRealIndex(row);
                return (dataBaseIndex < 3); // row 0, 1, 2                
               } 
            public JComponent getExpandedTreeviewComponent(int row)
               {
                int dataBaseIndex = self.convertRowToRealIndex(row);
                switch (dataBaseIndex)
                   {
                    case 0: // row 0
                        return get_PassengersTable_ScrollPane();
                    case 1: // row 1
                        return get_CancelPanel(); 
                    default: // row 2
                        return new JLabel("<html><font color=green><B> Arrived on : </B></font>" + new Date());                                                                                         
                   }                    
               }            
           });
        return super.init_FlightsTable(self);
       } /* End of Method: init_FlightsTable */

    /**
     * loadPassengersTable
     */
    private void loadPassengersTable()
       {
        if (get_JRadioButtonFull().isSelected())
           {
            try // JbcBeans
               {
                get_PassengerName().setCellRenderer(new JbcCellRenderer());
                get_PassengerName().setCellEditor(new JbcCellEditorTextField());
                get_Connection().setCellRenderer(new JbcCellRendererBoolean());
                get_Connection().setCellEditor(new JbcCellEditorNoEditable());  
                get_Row().setCellRenderer(new JbcCellRendererCenter());
                get_Row().setCellEditor(new JbcCellEditorComboBox(stringsRow)); 
                get_Seat().setCellRenderer(new JbcCellRendererCenter());
                get_Seat().setCellEditor(new JbcCellEditorInteger(1,10)); 
                get_Class().setCellRenderer(new JbcCellRendererCenter());
                get_Class().setCellEditor(new JbcCellEditorStrings(stringsClass));              
               }
            catch (java.lang.Throwable exc) 
               {       
                get_JRadioButtonFull().setSelected(false);          
               }             
           }
        if (!get_JRadioButtonFull().isSelected())
           {       
            get_PassengerName().setCellRenderer(new JbcCellRenderer());
            get_PassengerName().setCellEditor(new JbcCellEditorTextField());
            get_Connection().setCellRenderer(new JbcCellRendererBoolean());
            get_Connection().setCellEditor(new JbcCellEditorNoEditable());  
            get_Row().setCellRenderer(new JbcCellRendererCenter());
            get_Row().setCellEditor(new JbcCellEditorComboBox(stringsRow));
            get_Seat().setCellRenderer(new JbcCellRendererCenter());
            get_Class().setCellRenderer(new JbcCellRendererCenter());
            get_Class().setCellEditor(new JbcCellEditorNoEditable());            
           }  
                        
        JbcGridDefaultTableModel tm = (JbcGridDefaultTableModel)get_PassengersTable().getModel();   
        Vector data;
        data = new Vector();
        data.add("Carter John");
        data.add(Boolean.TRUE);
        data.add("A");
        data.add(new Integer(1)); 
        data.add("Economy");               
        tm.addRow(data);  
                   
        data = new Vector();
        data.add("Sullivan Allison");
        data.add(Boolean.FALSE);
        data.add("B");
        data.add(new Integer(2)); 
        data.add("First");               
        tm.addRow(data);  
                   
        data = new Vector();
        data.add("Paul Aaron");
        data.add(Boolean.FALSE);
        data.add("C");
        data.add(new Integer(3)); 
        data.add("First");               
        tm.addRow(data); 
                   
        data = new Vector();
        data.add("Karlson Bjorn");
        data.add(Boolean.FALSE);
        data.add("D");
        data.add(new Integer(4)); 
        data.add("First");               
        tm.addRow(data);                      
       } /* End of Method : loadPassengersTable */
       
    /**
     * Method: init_PassengersTable <br>
     * @param Instance of jbc.grid.JbcGridTable
     * @return jbc.grid.JbcGridTable
     */
    protected jbc.grid.JbcGridTable init_PassengersTable(jbc.grid.JbcGridTable self)
       {
        self.setModel(new JbcGridDefaultTableModel()
           {  
            public boolean isExpandableTreeview(int row)
               {
                return (row == 0);
               } 
            public JComponent getExpandedTreeviewComponent(int row)
               {
                return get_ConnectionsTable_ScrollPane();
               }            
           });
        return super.init_PassengersTable(self);
       } /* End of Method: init_PassengersTable */
       
    /**
     * loadConnectionsTable
     */
    private void loadConnectionsTable()
       {
        if (get_JRadioButtonFull().isSelected())
           {
            try // JbcBeans
               {
                get_ConnectionFlight().setCellRenderer(new JbcCellRendererCenter());
                get_ConnectionFlight().setCellEditor(new JbcCellEditorNoEditable());
                get_ConnectionDestination().setCellRenderer(new JbcCellRenderer());
                get_ConnectionDestination().setCellEditor(new JbcCellEditorTextField());  
                JbcCellEditorDateTime cedt = new JbcCellEditorDateTime(JbcDateTimeChooser.FULL);                              
                get_ConnectionDepartureDate().setCellEditor(cedt);
                JbcDateTimeChooser dtc = (JbcDateTimeChooser)cedt.getComponent();
                dtc.setSecondEnabled(false);
                dtc.setClockWithAmPm(true);
                get_ConnectionDepartureDate().setCellRenderer(new JbcCellRendererDateTime(JbcDateTimeChooser.FULL));            
               }
            catch (java.lang.Throwable exc) 
               {
                get_JRadioButtonFull().setSelected(false);            
               }             
           }
        if (!get_JRadioButtonFull().isSelected())
           {
            get_ConnectionFlight().setCellRenderer(new JbcCellRendererCenter());
            get_ConnectionFlight().setCellEditor(new JbcCellEditorNoEditable());
            get_ConnectionDestination().setCellRenderer(new JbcCellRenderer());
            get_ConnectionDestination().setCellEditor(new JbcCellEditorTextField());  
            get_ConnectionDepartureDate().setCellRenderer(new JbcCellRenderer());            
           }   
        
        JbcGridDefaultTableModel tm = (JbcGridDefaultTableModel)get_ConnectionsTable().getModel();   
        Vector data;
        data = new Vector();
        data.add(new Integer(5067));
        data.add("Nice");        
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(new Date());
        calendar.set(Calendar.HOUR_OF_DAY,calendar.get(Calendar.HOUR_OF_DAY) + 7);
        calendar.set(Calendar.MINUTE,calendar.get(Calendar.MINUTE) + 22);
        calendar.set(Calendar.SECOND, 0);        
        data.add(calendar.getTime());
        tm.addRow(data);                                  
       } /* End of Method : loadConnectionsTable */
       
    /**
     * Method: init_ConnectionsTable <br>
     * @param Instance of jbc.grid.JbcGridTable
     * @return jbc.grid.JbcGridTable
     */
    protected jbc.grid.JbcGridTable init_ConnectionsTable(jbc.grid.JbcGridTable self)
       {
        return super.init_ConnectionsTable(self);
       } /* End of Method: init_ConnectionsTable */
                  
    /**
     * Method: main <br>
     * Note: Called only if we're an application. <br>
     * @param java.lang.String[] args the command line arguments
     * @return void
     */
    public static void main(java.lang.String[] args)
       {              
        try
           {
            /* Set native look and feel */
            javax.swing.UIManager.setLookAndFeel(javax.swing.UIManager.getSystemLookAndFeelClassName());
           }
        catch (Exception exc)
           {
           }

        GridTreeView self = new GridTreeView();
        self.get_JWindow().setVisible(true);        
       } /* End of Method: main */
             
    /**
     * Method: generalHandleException <br>
     * @param java.lang.Throwable exception
     * @return void
     */
    protected void generalHandleException(java.lang.Throwable exc)
       {
        exc.printStackTrace(System.err);
       } /* End of Method: generalHandleException */

    /**
     * Method: JButton_action_actionPerformed <br>
     * Adapter: ActionAdapter <br>
     * Interface: java.awt.event.ActionListener <br>
     * Note  : This method is called when an action occurs.  <br>
     * @param java.awt.event.ActionEvent evt
     * @return void
     */
    protected void JButton_action_actionPerformed(java.awt.event.ActionEvent evt)
       {
        get_JWindow().setVisible(false);   
        loadFlightsTable();   
        loadPassengersTable();  
        loadConnectionsTable(); 
        get_JFrame().setVisible(true);        
       } /* End of Method: JButton_action_actionPerformed */

    /**
     * Method: JSliderRowHeight_change_stateChanged <br>
     * Adapter: ChangeAdapter <br>
     * Interface: javax.swing.event.ChangeListener <br>
     * Note  : This method is called when the target of the listener
     *         has changed its state.  <br>
     * @param javax.swing.event.ChangeEvent evt
     * @return void
     */
    protected void JSliderRowHeight_change_stateChanged(javax.swing.event.ChangeEvent evt)
       {
        get_FlightsTable().collapseAllTreeviews();
        get_FlightsTable().setRowHeight(get_JSliderRowHeight().getValue());    
       } /* End of Method: JSliderRowHeight_change_stateChanged */

   } /* End of Class: GridTreeView */



